function [Sk, Sv]=S(x, u0, xi, a, R, dt, PLANT,REWARD)

% computes path cost of a trajectory.
% x is n times N, n is dimension of the problem, N is length of time trace
% u0 is m times N, m is dimension of the control

l1=1;
l2=2;
N=size(x,2);
switch PLANT
case 'acrobot',
	switch REWARD
	case 'pathcost'
	case 'endcost'
		Sv=-a*(l1*sin(x(1,N))+l2*sin(x(2,N)));
	end
case 'singlewell'
	switch REWARD
	case 'pathcost'
	case 'endcost'
		Sv=a/2*sum(x(:,N).^2);
	end
end;

Sk=0.5*R*dt*sum(u0.^2,2)+R*sum(xi.*u0,2);
