function [xi,dx1,l,ss]=compute_xi(x, x_traj, xi_traj, S_traj,t, TIMEDEPENDENT, NEIGHBORHOOD,rho,rhomax,n_neighbor,lambda,PLANT)

% x is point of interest where u is computed n times 1
% x_traj are the states of all trajectories at time t 
% t is the current time
% TIMEDEPENDENT = 1 when a time dependent control is computed. only nearby states at the same time are used

S_traj=S_traj-min(S_traj);
wall=exp(-S_traj/lambda);
n=size(x_traj,1);
N=size(x_traj,2);

% compute set of points near x
	distance=zeros(n,N);
	switch PLANT
	case 'singlewell'
		distance=sum((x*ones(1,N)-x_traj).^2,1);
	case 'acrobot'
		klad=exp(i*x(1:2)*ones(1,N))-exp(i*x_traj(1:2,:));
		distance(1:2,:)=abs(klad.*conj(klad));
		distance(3:4,:)=abs(x(3:4)*ones(1,N)-x_traj(3:4,:));
	end
	maxdistance=max(distance,[],2);
		
	switch NEIGHBORHOOD
	case 'size'
		iset=find(all(distance<=rho*maxdistance*ones(1,N),1));
		l=length(iset);
   		w_iset=wall(iset);
   		alpha=w_iset/sum(w_iset);
		dx1=rho;
   		while (l==0)&(dx1<rhomax)
   			dx1=dx1+rho;
   			iset=find(all(distance<=dx1*maxdistance*ones(1,N),1));
   			l=length(iset);
   			w_iset=wall(iset);
   			alpha=w_iset/sum(w_iset);
   		end;
		if (l==0), fprintf('ERROR: no neighbors found\n'); 
			distance
			maxdistance
			iset
			dx1
			x
			x_traj
			pause; end;
		
	case 'number'
		[distance_sort, idistance]=sort(distance, 'ascend');
   		iset=idistance(1:n_neighbor);
		l=length(iset);
   		w_iset=wall(iset);
   		alpha=w_iset/sum(w_iset);
		dx1=distance(idistance(n_neighbor));	% largest distance in neighborhood
	end;
	ss=1/sum(alpha.^2);
	
	x_iset=x_traj(:,iset);			% n times length(iset)
	xi_iset=xi_traj(:,iset);		% m times length(iset)
		
	barx=x_iset*alpha';
	barxi=xi_iset*alpha';
	klad=x_iset-barx*ones(1,l);
	chi=klad*spdiags(alpha',0,l,l)*klad';
	deltax=x-barx;
	if (l>=size(x,1))&(sum(deltax.^2)>0.01)&&(min(eig(chi))>sum(deltax.^2))
		disp('chi used')
		klad1=xi_iset-barxi*ones(1,length(iset));
   		etaxi=klad1*spdiags(alpha',0,l,l)*klad';
   		wxi=etaxi*inv(chi);
   		xi=wxi*deltax+barxi;
		%wxideltax(:,t+1)=wxi*deltax;
		%[wxi*deltax, barxi]
	else
		xi=barxi;
	end;
