function dSv1=dSv(x, a, dt, PLANT)

% computes path cost of a trajectory.
% x is n times N, n is dimension of the problem, N is length of time trace
% u0 is m times N, m is dimension of the control

switch PLANT
case 'acrobot',
	l1=1;
	l2=2;
	dSv1=-a*(l1*sin(x(1))+l2*sin(x(2)))*dt+1000*(a*x(3)^2+a*x(4)^2);
case 'singlewell'
	dSv1=a/2*sum(x.^2)*dt;
case 'neuralnetwork'
	dSv1=a*(x(1)-0.5)^2;
case 'lorenz'
	dSv1=0;
end;

